#include <gdk/gdkglcontext.h>
#include <gdk/gdkgldebug.h>

#include "gtkglext_fbo_sl.h"

/*
 * GL_ARB_shader_objects
 */

static GdkGL_GL_ARB_shader_objects _procs_GL_ARB_shader_objects = {
  (GdkGLProc_glDeleteObjectARB) -1,
  (GdkGLProc_glGetHandleARB) -1,
  (GdkGLProc_glDetachObjectARB) -1,
  (GdkGLProc_glCreateShaderObjectARB) -1,
  (GdkGLProc_glShaderSourceARB) -1,
  (GdkGLProc_glCompileShaderARB) -1,
  (GdkGLProc_glCreateProgramObjectARB) -1,
  (GdkGLProc_glAttachObjectARB) -1,
  (GdkGLProc_glLinkProgramARB) -1,
  (GdkGLProc_glUseProgramObjectARB) -1,
  (GdkGLProc_glValidateProgramARB) -1,
  (GdkGLProc_glUniform1fARB) -1,
  (GdkGLProc_glUniform2fARB) -1,
  (GdkGLProc_glUniform3fARB) -1,
  (GdkGLProc_glUniform4fARB) -1,
  (GdkGLProc_glUniform1iARB) -1,
  (GdkGLProc_glUniform2iARB) -1,
  (GdkGLProc_glUniform3iARB) -1,
  (GdkGLProc_glUniform4iARB) -1,
  (GdkGLProc_glUniform1fvARB) -1,
  (GdkGLProc_glUniform2fvARB) -1,
  (GdkGLProc_glUniform3fvARB) -1,
  (GdkGLProc_glUniform4fvARB) -1,
  (GdkGLProc_glUniform1ivARB) -1,
  (GdkGLProc_glUniform2ivARB) -1,
  (GdkGLProc_glUniform3ivARB) -1,
  (GdkGLProc_glUniform4ivARB) -1,
  (GdkGLProc_glUniformMatrix2fvARB) -1,
  (GdkGLProc_glUniformMatrix3fvARB) -1,
  (GdkGLProc_glUniformMatrix4fvARB) -1,
  (GdkGLProc_glGetObjectParameterfvARB) -1,
  (GdkGLProc_glGetObjectParameterivARB) -1,
  (GdkGLProc_glGetInfoLogARB) -1,
  (GdkGLProc_glGetAttachedObjectsARB) -1,
  (GdkGLProc_glGetUniformLocationARB) -1,
  (GdkGLProc_glGetActiveUniformARB) -1,
  (GdkGLProc_glGetUniformfvARB) -1,
  (GdkGLProc_glGetUniformivARB) -1,
  (GdkGLProc_glGetShaderSourceARB) -1
};

/* glDeleteObjectARB */
GdkGLProc
gdk_gl_get_glDeleteObjectARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glDeleteObjectARB == (GdkGLProc_glDeleteObjectARB) -1)
    _procs_GL_ARB_shader_objects.glDeleteObjectARB =
      (GdkGLProc_glDeleteObjectARB) gdk_gl_get_proc_address ("glDeleteObjectARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glDeleteObjectARB () - %s",
               (_procs_GL_ARB_shader_objects.glDeleteObjectARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glDeleteObjectARB);
}

/* glGetHandleARB */
GdkGLProc
gdk_gl_get_glGetHandleARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetHandleARB == (GdkGLProc_glGetHandleARB) -1)
    _procs_GL_ARB_shader_objects.glGetHandleARB =
      (GdkGLProc_glGetHandleARB) gdk_gl_get_proc_address ("glGetHandleARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetHandleARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetHandleARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetHandleARB);
}

/* glDetachObjectARB */
GdkGLProc
gdk_gl_get_glDetachObjectARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glDetachObjectARB == (GdkGLProc_glDetachObjectARB) -1)
    _procs_GL_ARB_shader_objects.glDetachObjectARB =
      (GdkGLProc_glDetachObjectARB) gdk_gl_get_proc_address ("glDetachObjectARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glDetachObjectARB () - %s",
               (_procs_GL_ARB_shader_objects.glDetachObjectARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glDetachObjectARB);
}

/* glCreateShaderObjectARB */
GdkGLProc
gdk_gl_get_glCreateShaderObjectARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glCreateShaderObjectARB == (GdkGLProc_glCreateShaderObjectARB) -1)
    _procs_GL_ARB_shader_objects.glCreateShaderObjectARB =
      (GdkGLProc_glCreateShaderObjectARB) gdk_gl_get_proc_address ("glCreateShaderObjectARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glCreateShaderObjectARB () - %s",
               (_procs_GL_ARB_shader_objects.glCreateShaderObjectARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glCreateShaderObjectARB);
}

/* glShaderSourceARB */
GdkGLProc
gdk_gl_get_glShaderSourceARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glShaderSourceARB == (GdkGLProc_glShaderSourceARB) -1)
    _procs_GL_ARB_shader_objects.glShaderSourceARB =
      (GdkGLProc_glShaderSourceARB) gdk_gl_get_proc_address ("glShaderSourceARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glShaderSourceARB () - %s",
               (_procs_GL_ARB_shader_objects.glShaderSourceARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glShaderSourceARB);
}

/* glCompileShaderARB */
GdkGLProc
gdk_gl_get_glCompileShaderARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glCompileShaderARB == (GdkGLProc_glCompileShaderARB) -1)
    _procs_GL_ARB_shader_objects.glCompileShaderARB =
      (GdkGLProc_glCompileShaderARB) gdk_gl_get_proc_address ("glCompileShaderARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glCompileShaderARB () - %s",
               (_procs_GL_ARB_shader_objects.glCompileShaderARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glCompileShaderARB);
}

/* glCreateProgramObjectARB */
GdkGLProc
gdk_gl_get_glCreateProgramObjectARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glCreateProgramObjectARB == (GdkGLProc_glCreateProgramObjectARB) -1)
    _procs_GL_ARB_shader_objects.glCreateProgramObjectARB =
      (GdkGLProc_glCreateProgramObjectARB) gdk_gl_get_proc_address ("glCreateProgramObjectARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glCreateProgramObjectARB () - %s",
               (_procs_GL_ARB_shader_objects.glCreateProgramObjectARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glCreateProgramObjectARB);
}

/* glAttachObjectARB */
GdkGLProc
gdk_gl_get_glAttachObjectARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glAttachObjectARB == (GdkGLProc_glAttachObjectARB) -1)
    _procs_GL_ARB_shader_objects.glAttachObjectARB =
      (GdkGLProc_glAttachObjectARB) gdk_gl_get_proc_address ("glAttachObjectARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glAttachObjectARB () - %s",
               (_procs_GL_ARB_shader_objects.glAttachObjectARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glAttachObjectARB);
}

/* glLinkProgramARB */
GdkGLProc
gdk_gl_get_glLinkProgramARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glLinkProgramARB == (GdkGLProc_glLinkProgramARB) -1)
    _procs_GL_ARB_shader_objects.glLinkProgramARB =
      (GdkGLProc_glLinkProgramARB) gdk_gl_get_proc_address ("glLinkProgramARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glLinkProgramARB () - %s",
               (_procs_GL_ARB_shader_objects.glLinkProgramARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glLinkProgramARB);
}

/* glUseProgramObjectARB */
GdkGLProc
gdk_gl_get_glUseProgramObjectARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUseProgramObjectARB == (GdkGLProc_glUseProgramObjectARB) -1)
    _procs_GL_ARB_shader_objects.glUseProgramObjectARB =
      (GdkGLProc_glUseProgramObjectARB) gdk_gl_get_proc_address ("glUseProgramObjectARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUseProgramObjectARB () - %s",
               (_procs_GL_ARB_shader_objects.glUseProgramObjectARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUseProgramObjectARB);
}

/* glValidateProgramARB */
GdkGLProc
gdk_gl_get_glValidateProgramARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glValidateProgramARB == (GdkGLProc_glValidateProgramARB) -1)
    _procs_GL_ARB_shader_objects.glValidateProgramARB =
      (GdkGLProc_glValidateProgramARB) gdk_gl_get_proc_address ("glValidateProgramARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glValidateProgramARB () - %s",
               (_procs_GL_ARB_shader_objects.glValidateProgramARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glValidateProgramARB);
}

/* glUniform1fARB */
GdkGLProc
gdk_gl_get_glUniform1fARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform1fARB == (GdkGLProc_glUniform1fARB) -1)
    _procs_GL_ARB_shader_objects.glUniform1fARB =
      (GdkGLProc_glUniform1fARB) gdk_gl_get_proc_address ("glUniform1fARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform1fARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform1fARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform1fARB);
}

/* glUniform2fARB */
GdkGLProc
gdk_gl_get_glUniform2fARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform2fARB == (GdkGLProc_glUniform2fARB) -1)
    _procs_GL_ARB_shader_objects.glUniform2fARB =
      (GdkGLProc_glUniform2fARB) gdk_gl_get_proc_address ("glUniform2fARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform2fARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform2fARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform2fARB);
}

/* glUniform3fARB */
GdkGLProc
gdk_gl_get_glUniform3fARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform3fARB == (GdkGLProc_glUniform3fARB) -1)
    _procs_GL_ARB_shader_objects.glUniform3fARB =
      (GdkGLProc_glUniform3fARB) gdk_gl_get_proc_address ("glUniform3fARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform3fARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform3fARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform3fARB);
}

/* glUniform4fARB */
GdkGLProc
gdk_gl_get_glUniform4fARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform4fARB == (GdkGLProc_glUniform4fARB) -1)
    _procs_GL_ARB_shader_objects.glUniform4fARB =
      (GdkGLProc_glUniform4fARB) gdk_gl_get_proc_address ("glUniform4fARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform4fARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform4fARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform4fARB);
}

/* glUniform1iARB */
GdkGLProc
gdk_gl_get_glUniform1iARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform1iARB == (GdkGLProc_glUniform1iARB) -1)
    _procs_GL_ARB_shader_objects.glUniform1iARB =
      (GdkGLProc_glUniform1iARB) gdk_gl_get_proc_address ("glUniform1iARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform1iARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform1iARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform1iARB);
}

/* glUniform2iARB */
GdkGLProc
gdk_gl_get_glUniform2iARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform2iARB == (GdkGLProc_glUniform2iARB) -1)
    _procs_GL_ARB_shader_objects.glUniform2iARB =
      (GdkGLProc_glUniform2iARB) gdk_gl_get_proc_address ("glUniform2iARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform2iARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform2iARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform2iARB);
}

/* glUniform3iARB */
GdkGLProc
gdk_gl_get_glUniform3iARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform3iARB == (GdkGLProc_glUniform3iARB) -1)
    _procs_GL_ARB_shader_objects.glUniform3iARB =
      (GdkGLProc_glUniform3iARB) gdk_gl_get_proc_address ("glUniform3iARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform3iARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform3iARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform3iARB);
}

/* glUniform4iARB */
GdkGLProc
gdk_gl_get_glUniform4iARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform4iARB == (GdkGLProc_glUniform4iARB) -1)
    _procs_GL_ARB_shader_objects.glUniform4iARB =
      (GdkGLProc_glUniform4iARB) gdk_gl_get_proc_address ("glUniform4iARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform4iARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform4iARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform4iARB);
}

/* glUniform1fvARB */
GdkGLProc
gdk_gl_get_glUniform1fvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform1fvARB == (GdkGLProc_glUniform1fvARB) -1)
    _procs_GL_ARB_shader_objects.glUniform1fvARB =
      (GdkGLProc_glUniform1fvARB) gdk_gl_get_proc_address ("glUniform1fvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform1fvARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform1fvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform1fvARB);
}

/* glUniform2fvARB */
GdkGLProc
gdk_gl_get_glUniform2fvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform2fvARB == (GdkGLProc_glUniform2fvARB) -1)
    _procs_GL_ARB_shader_objects.glUniform2fvARB =
      (GdkGLProc_glUniform2fvARB) gdk_gl_get_proc_address ("glUniform2fvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform2fvARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform2fvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform2fvARB);
}

/* glUniform3fvARB */
GdkGLProc
gdk_gl_get_glUniform3fvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform3fvARB == (GdkGLProc_glUniform3fvARB) -1)
    _procs_GL_ARB_shader_objects.glUniform3fvARB =
      (GdkGLProc_glUniform3fvARB) gdk_gl_get_proc_address ("glUniform3fvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform3fvARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform3fvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform3fvARB);
}

/* glUniform4fvARB */
GdkGLProc
gdk_gl_get_glUniform4fvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform4fvARB == (GdkGLProc_glUniform4fvARB) -1)
    _procs_GL_ARB_shader_objects.glUniform4fvARB =
      (GdkGLProc_glUniform4fvARB) gdk_gl_get_proc_address ("glUniform4fvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform4fvARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform4fvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform4fvARB);
}


/* glUniform1ivARB */
GdkGLProc
gdk_gl_get_glUniform1ivARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform1ivARB == (GdkGLProc_glUniform1ivARB) -1)
    _procs_GL_ARB_shader_objects.glUniform1ivARB =
      (GdkGLProc_glUniform1ivARB) gdk_gl_get_proc_address ("glUniform1ivARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform1ivARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform1ivARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform1ivARB);
}

/* glUniform2ivARB */
GdkGLProc
gdk_gl_get_glUniform2ivARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform2ivARB == (GdkGLProc_glUniform2ivARB) -1)
    _procs_GL_ARB_shader_objects.glUniform2ivARB =
      (GdkGLProc_glUniform2ivARB) gdk_gl_get_proc_address ("glUniform2ivARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform2ivARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform2ivARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform2ivARB);
}

/* glUniform3ivARB */
GdkGLProc
gdk_gl_get_glUniform3ivARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform3ivARB == (GdkGLProc_glUniform3ivARB) -1)
    _procs_GL_ARB_shader_objects.glUniform3ivARB =
      (GdkGLProc_glUniform3ivARB) gdk_gl_get_proc_address ("glUniform3ivARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform3ivARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform3ivARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform3ivARB);
}

/* glUniform4ivARB */
GdkGLProc
gdk_gl_get_glUniform4ivARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniform4ivARB == (GdkGLProc_glUniform4ivARB) -1)
    _procs_GL_ARB_shader_objects.glUniform4ivARB =
      (GdkGLProc_glUniform4ivARB) gdk_gl_get_proc_address ("glUniform4ivARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniform4ivARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniform4ivARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniform4ivARB);
}

/* glUniformMatrix2fvARB */
GdkGLProc
gdk_gl_get_glUniformMatrix2fvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniformMatrix2fvARB == (GdkGLProc_glUniformMatrix2fvARB) -1)
    _procs_GL_ARB_shader_objects.glUniformMatrix2fvARB =
      (GdkGLProc_glUniformMatrix2fvARB) gdk_gl_get_proc_address ("glUniformMatrix2fvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniformMatrix2fvARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniformMatrix2fvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniformMatrix2fvARB);
}

/* glUniformMatrix3fvARB */
GdkGLProc
gdk_gl_get_glUniformMatrix3fvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniformMatrix3fvARB == (GdkGLProc_glUniformMatrix3fvARB) -1)
    _procs_GL_ARB_shader_objects.glUniformMatrix3fvARB =
      (GdkGLProc_glUniformMatrix3fvARB) gdk_gl_get_proc_address ("glUniformMatrix3fvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniformMatrix3fvARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniformMatrix3fvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniformMatrix3fvARB);
}

/* glUniformMatrix4fvARB */
GdkGLProc
gdk_gl_get_glUniformMatrix4fvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glUniformMatrix4fvARB == (GdkGLProc_glUniformMatrix4fvARB) -1)
    _procs_GL_ARB_shader_objects.glUniformMatrix4fvARB =
      (GdkGLProc_glUniformMatrix4fvARB) gdk_gl_get_proc_address ("glUniformMatrix4fvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glUniformMatrix4fvARB () - %s",
               (_procs_GL_ARB_shader_objects.glUniformMatrix4fvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glUniformMatrix4fvARB);
}

/* glGetObjectParameterfvARB */
GdkGLProc
gdk_gl_get_glGetObjectParameterfvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetObjectParameterfvARB == (GdkGLProc_glGetObjectParameterfvARB) -1)
    _procs_GL_ARB_shader_objects.glGetObjectParameterfvARB =
      (GdkGLProc_glGetObjectParameterfvARB) gdk_gl_get_proc_address ("glGetObjectParameterfvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetObjectParameterfvARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetObjectParameterfvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetObjectParameterfvARB);
}

/* glGetObjectParameterivARB */
GdkGLProc
gdk_gl_get_glGetObjectParameterivARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetObjectParameterivARB == (GdkGLProc_glGetObjectParameterivARB) -1)
    _procs_GL_ARB_shader_objects.glGetObjectParameterivARB =
      (GdkGLProc_glGetObjectParameterivARB) gdk_gl_get_proc_address ("glGetObjectParameterivARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetObjectParameterivARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetObjectParameterivARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetObjectParameterivARB);
}

/* glGetInfoLogARB */
GdkGLProc
gdk_gl_get_glGetInfoLogARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetInfoLogARB == (GdkGLProc_glGetInfoLogARB) -1)
    _procs_GL_ARB_shader_objects.glGetInfoLogARB =
      (GdkGLProc_glGetInfoLogARB) gdk_gl_get_proc_address ("glGetInfoLogARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetInfoLogARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetInfoLogARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetInfoLogARB);
}

/* glGetAttachedObjectsARB */
GdkGLProc
gdk_gl_get_glGetAttachedObjectsARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetAttachedObjectsARB == (GdkGLProc_glGetAttachedObjectsARB) -1)
    _procs_GL_ARB_shader_objects.glGetAttachedObjectsARB =
      (GdkGLProc_glGetAttachedObjectsARB) gdk_gl_get_proc_address ("glGetAttachedObjectsARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetAttachedObjectsARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetAttachedObjectsARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetAttachedObjectsARB);
}

/* glGetUniformLocationARB */
GdkGLProc
gdk_gl_get_glGetUniformLocationARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetUniformLocationARB == (GdkGLProc_glGetUniformLocationARB) -1)
    _procs_GL_ARB_shader_objects.glGetUniformLocationARB =
      (GdkGLProc_glGetUniformLocationARB) gdk_gl_get_proc_address ("glGetUniformLocationARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetUniformLocationARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetUniformLocationARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetUniformLocationARB);
}

/* glGetActiveUniformARB */
GdkGLProc
gdk_gl_get_glGetActiveUniformARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetActiveUniformARB == (GdkGLProc_glGetActiveUniformARB) -1)
    _procs_GL_ARB_shader_objects.glGetActiveUniformARB =
      (GdkGLProc_glGetActiveUniformARB) gdk_gl_get_proc_address ("glGetActiveUniformARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetActiveUniformARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetActiveUniformARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetActiveUniformARB);
}

/* glGetUniformfvARB */
GdkGLProc
gdk_gl_get_glGetUniformfvARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetUniformfvARB == (GdkGLProc_glGetUniformfvARB) -1)
    _procs_GL_ARB_shader_objects.glGetUniformfvARB =
      (GdkGLProc_glGetUniformfvARB) gdk_gl_get_proc_address ("glGetUniformfvARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetUniformfvARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetUniformfvARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetUniformfvARB);
}

/* glGetUniformivARB */
GdkGLProc
gdk_gl_get_glGetUniformivARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetUniformivARB == (GdkGLProc_glGetUniformivARB) -1)
    _procs_GL_ARB_shader_objects.glGetUniformivARB =
      (GdkGLProc_glGetUniformivARB) gdk_gl_get_proc_address ("glGetUniformivARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetUniformivARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetUniformivARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetUniformivARB);
}

/* glGetShaderSourceARB */
GdkGLProc
gdk_gl_get_glGetShaderSourceARB (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_ARB_shader_objects.glGetShaderSourceARB == (GdkGLProc_glGetShaderSourceARB) -1)
    _procs_GL_ARB_shader_objects.glGetShaderSourceARB =
      (GdkGLProc_glGetShaderSourceARB) gdk_gl_get_proc_address ("glGetShaderSourceARB");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetShaderSourceARB () - %s",
               (_procs_GL_ARB_shader_objects.glGetShaderSourceARB) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_ARB_shader_objects.glGetShaderSourceARB);
}

/* Get GL_ARB_shader_objects functions */
GdkGL_GL_ARB_shader_objects *
gdk_gl_get_GL_ARB_shader_objects (void)
{
  static gint supported = -1;

  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (supported == -1)
    {
      supported = gdk_gl_query_gl_extension ("GL_ARB_shader_objects");
      supported &= gdk_gl_query_gl_extension ("GL_ARB_vertex_shader");
      supported &= gdk_gl_query_gl_extension ("GL_ARB_fragment_shader");

      if (supported)
        {
          supported &= (gdk_gl_get_glDeleteObjectARB () != NULL);
          supported &= (gdk_gl_get_glGetHandleARB () != NULL);
          supported &= (gdk_gl_get_glDetachObjectARB () != NULL);
          supported &= (gdk_gl_get_glCreateShaderObjectARB () != NULL);
          supported &= (gdk_gl_get_glShaderSourceARB () != NULL);
          supported &= (gdk_gl_get_glCompileShaderARB () != NULL);
          supported &= (gdk_gl_get_glCreateProgramObjectARB () != NULL);
          supported &= (gdk_gl_get_glAttachObjectARB () != NULL);
          supported &= (gdk_gl_get_glLinkProgramARB () != NULL);
          supported &= (gdk_gl_get_glUseProgramObjectARB () != NULL);
          supported &= (gdk_gl_get_glValidateProgramARB () != NULL);
          supported &= (gdk_gl_get_glUniform1fARB () != NULL);
          supported &= (gdk_gl_get_glUniform2fARB () != NULL);
          supported &= (gdk_gl_get_glUniform3fARB () != NULL);
          supported &= (gdk_gl_get_glUniform4fARB () != NULL);
          supported &= (gdk_gl_get_glUniform1iARB () != NULL);
          supported &= (gdk_gl_get_glUniform2iARB () != NULL);
          supported &= (gdk_gl_get_glUniform3iARB () != NULL);
          supported &= (gdk_gl_get_glUniform4iARB () != NULL);
          supported &= (gdk_gl_get_glUniform1fvARB () != NULL);
          supported &= (gdk_gl_get_glUniform2fvARB () != NULL);
          supported &= (gdk_gl_get_glUniform3fvARB () != NULL);
          supported &= (gdk_gl_get_glUniform4fvARB () != NULL);
          supported &= (gdk_gl_get_glUniform1ivARB () != NULL);
          supported &= (gdk_gl_get_glUniform2ivARB () != NULL);
          supported &= (gdk_gl_get_glUniform3ivARB () != NULL);
          supported &= (gdk_gl_get_glUniform4ivARB () != NULL);
          supported &= (gdk_gl_get_glUniformMatrix2fvARB () != NULL);
          supported &= (gdk_gl_get_glUniformMatrix3fvARB () != NULL);
          supported &= (gdk_gl_get_glUniformMatrix4fvARB () != NULL);
          supported &= (gdk_gl_get_glGetObjectParameterfvARB () != NULL);
          supported &= (gdk_gl_get_glGetObjectParameterivARB () != NULL);
          supported &= (gdk_gl_get_glGetInfoLogARB () != NULL);
          supported &= (gdk_gl_get_glGetAttachedObjectsARB () != NULL);
          supported &= (gdk_gl_get_glGetUniformLocationARB () != NULL);
          supported &= (gdk_gl_get_glGetActiveUniformARB () != NULL);
          supported &= (gdk_gl_get_glGetUniformfvARB () != NULL);
          supported &= (gdk_gl_get_glGetUniformivARB () != NULL);
          supported &= (gdk_gl_get_glGetShaderSourceARB () != NULL);
        }
    }

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_GL_ARB_shader_objects () - %s",
               (supported) ? "supported" : "not supported"));

  if (!supported)
    return NULL;

  return &_procs_GL_ARB_shader_objects;
}

/*
 * GL_EXT_framebuffer_object
 */

static GdkGL_GL_EXT_framebuffer_object _procs_GL_EXT_framebuffer_object = {
  (GdkGLProc_glIsRenderbufferEXT) -1,
  (GdkGLProc_glBindRenderbufferEXT) -1,
  (GdkGLProc_glDeleteRenderbuffersEXT) -1,
  (GdkGLProc_glGenRenderbuffersEXT) -1,
  (GdkGLProc_glRenderbufferStorageEXT) -1,
  (GdkGLProc_glGetRenderbufferParameterivEXT) -1,
  (GdkGLProc_glIsFramebufferEXT) -1,
  (GdkGLProc_glBindFramebufferEXT) -1,
  (GdkGLProc_glDeleteFramebuffersEXT) -1,
  (GdkGLProc_glGenFramebuffersEXT) -1,
  (GdkGLProc_glCheckFramebufferStatusEXT) -1,
  (GdkGLProc_glFramebufferTexture1DEXT) -1,
  (GdkGLProc_glFramebufferTexture2DEXT) -1,
  (GdkGLProc_glFramebufferTexture3DEXT) -1,
  (GdkGLProc_glFramebufferRenderbufferEXT) -1,
  (GdkGLProc_glGetFramebufferAttachmentParameterivEXT) -1,
  (GdkGLProc_glGenerateMipmapEXT) -1
};

/* glIsRenderbufferEXT */
GdkGLProc
gdk_gl_get_glIsRenderbufferEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glIsRenderbufferEXT == (GdkGLProc_glIsRenderbufferEXT) -1)
    _procs_GL_EXT_framebuffer_object.glIsRenderbufferEXT =
      (GdkGLProc_glIsRenderbufferEXT) gdk_gl_get_proc_address ("glIsRenderbufferEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glIsRenderbufferEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glIsRenderbufferEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glIsRenderbufferEXT);
}

/* glBindRenderbufferEXT */
GdkGLProc
gdk_gl_get_glBindRenderbufferEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glBindRenderbufferEXT == (GdkGLProc_glBindRenderbufferEXT) -1)
    _procs_GL_EXT_framebuffer_object.glBindRenderbufferEXT =
      (GdkGLProc_glBindRenderbufferEXT) gdk_gl_get_proc_address ("glBindRenderbufferEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glBindRenderbufferEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glBindRenderbufferEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glBindRenderbufferEXT);
}

/* glDeleteRenderbuffersEXT */
GdkGLProc
gdk_gl_get_glDeleteRenderbuffersEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glDeleteRenderbuffersEXT == (GdkGLProc_glDeleteRenderbuffersEXT) -1)
    _procs_GL_EXT_framebuffer_object.glDeleteRenderbuffersEXT =
      (GdkGLProc_glDeleteRenderbuffersEXT) gdk_gl_get_proc_address ("glDeleteRenderbuffersEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glDeleteRenderbuffersEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glDeleteRenderbuffersEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glDeleteRenderbuffersEXT);
}

/* glGenRenderbuffersEXT */
GdkGLProc
gdk_gl_get_glGenRenderbuffersEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glGenRenderbuffersEXT == (GdkGLProc_glGenRenderbuffersEXT) -1)
    _procs_GL_EXT_framebuffer_object.glGenRenderbuffersEXT =
      (GdkGLProc_glGenRenderbuffersEXT) gdk_gl_get_proc_address ("glGenRenderbuffersEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGenRenderbuffersEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glGenRenderbuffersEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glGenRenderbuffersEXT);
}

/* glRenderbufferStorageEXT */
GdkGLProc
gdk_gl_get_glRenderbufferStorageEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glRenderbufferStorageEXT == (GdkGLProc_glRenderbufferStorageEXT) -1)
    _procs_GL_EXT_framebuffer_object.glRenderbufferStorageEXT =
      (GdkGLProc_glRenderbufferStorageEXT) gdk_gl_get_proc_address ("glRenderbufferStorageEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glRenderbufferStorageEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glRenderbufferStorageEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glRenderbufferStorageEXT);
}

/* glGetRenderbufferParameterivEXT */
GdkGLProc
gdk_gl_get_glGetRenderbufferParameterivEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glGetRenderbufferParameterivEXT == (GdkGLProc_glGetRenderbufferParameterivEXT) -1)
    _procs_GL_EXT_framebuffer_object.glGetRenderbufferParameterivEXT =
      (GdkGLProc_glGetRenderbufferParameterivEXT) gdk_gl_get_proc_address ("glGetRenderbufferParameterivEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetRenderbufferParameterivEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glGetRenderbufferParameterivEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glGetRenderbufferParameterivEXT);
}

/* glIsFramebufferEXT */
GdkGLProc
gdk_gl_get_glIsFramebufferEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glIsFramebufferEXT == (GdkGLProc_glIsFramebufferEXT) -1)
    _procs_GL_EXT_framebuffer_object.glIsFramebufferEXT =
      (GdkGLProc_glIsFramebufferEXT) gdk_gl_get_proc_address ("glIsFramebufferEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glIsFramebufferEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glIsFramebufferEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glIsFramebufferEXT);
}

/* glBindFramebufferEXT */
GdkGLProc
gdk_gl_get_glBindFramebufferEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glBindFramebufferEXT == (GdkGLProc_glBindFramebufferEXT) -1)
    _procs_GL_EXT_framebuffer_object.glBindFramebufferEXT =
      (GdkGLProc_glBindFramebufferEXT) gdk_gl_get_proc_address ("glBindFramebufferEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glBindFramebufferEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glBindFramebufferEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glBindFramebufferEXT);
}

/* glDeleteFramebuffersEXT */
GdkGLProc
gdk_gl_get_glDeleteFramebuffersEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glDeleteFramebuffersEXT == (GdkGLProc_glDeleteFramebuffersEXT) -1)
    _procs_GL_EXT_framebuffer_object.glDeleteFramebuffersEXT =
      (GdkGLProc_glDeleteFramebuffersEXT) gdk_gl_get_proc_address ("glDeleteFramebuffersEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glDeleteFramebuffersEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glDeleteFramebuffersEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glDeleteFramebuffersEXT);
}

/* glGenFramebuffersEXT */
GdkGLProc
gdk_gl_get_glGenFramebuffersEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glGenFramebuffersEXT == (GdkGLProc_glGenFramebuffersEXT) -1)
    _procs_GL_EXT_framebuffer_object.glGenFramebuffersEXT =
      (GdkGLProc_glGenFramebuffersEXT) gdk_gl_get_proc_address ("glGenFramebuffersEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGenFramebuffersEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glGenFramebuffersEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glGenFramebuffersEXT);
}

/* glCheckFramebufferStatusEXT */
GdkGLProc
gdk_gl_get_glCheckFramebufferStatusEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glCheckFramebufferStatusEXT == (GdkGLProc_glCheckFramebufferStatusEXT) -1)
    _procs_GL_EXT_framebuffer_object.glCheckFramebufferStatusEXT =
      (GdkGLProc_glCheckFramebufferStatusEXT) gdk_gl_get_proc_address ("glCheckFramebufferStatusEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glCheckFramebufferStatusEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glCheckFramebufferStatusEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glCheckFramebufferStatusEXT);
}

/* glFramebufferTexture1DEXT */
GdkGLProc
gdk_gl_get_glFramebufferTexture1DEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glFramebufferTexture1DEXT == (GdkGLProc_glFramebufferTexture1DEXT) -1)
    _procs_GL_EXT_framebuffer_object.glFramebufferTexture1DEXT =
      (GdkGLProc_glFramebufferTexture1DEXT) gdk_gl_get_proc_address ("glFramebufferTexture1DEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glFramebufferTexture1DEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glFramebufferTexture1DEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glFramebufferTexture1DEXT);
}

/* glFramebufferTexture2DEXT */
GdkGLProc
gdk_gl_get_glFramebufferTexture2DEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glFramebufferTexture2DEXT == (GdkGLProc_glFramebufferTexture2DEXT) -1)
    _procs_GL_EXT_framebuffer_object.glFramebufferTexture2DEXT =
      (GdkGLProc_glFramebufferTexture2DEXT) gdk_gl_get_proc_address ("glFramebufferTexture2DEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glFramebufferTexture2DEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glFramebufferTexture2DEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glFramebufferTexture2DEXT);
}

/* glFramebufferTexture3DEXT */
GdkGLProc
gdk_gl_get_glFramebufferTexture3DEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glFramebufferTexture3DEXT == (GdkGLProc_glFramebufferTexture3DEXT) -1)
    _procs_GL_EXT_framebuffer_object.glFramebufferTexture3DEXT =
      (GdkGLProc_glFramebufferTexture3DEXT) gdk_gl_get_proc_address ("glFramebufferTexture3DEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glFramebufferTexture3DEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glFramebufferTexture3DEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glFramebufferTexture3DEXT);
}

/* glFramebufferRenderbufferEXT */
GdkGLProc
gdk_gl_get_glFramebufferRenderbufferEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glFramebufferRenderbufferEXT == (GdkGLProc_glFramebufferRenderbufferEXT) -1)
    _procs_GL_EXT_framebuffer_object.glFramebufferRenderbufferEXT =
      (GdkGLProc_glFramebufferRenderbufferEXT) gdk_gl_get_proc_address ("glFramebufferRenderbufferEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glFramebufferRenderbufferEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glFramebufferRenderbufferEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glFramebufferRenderbufferEXT);
}

/* glGetFramebufferAttachmentParameterivEXT */
GdkGLProc
gdk_gl_get_glGetFramebufferAttachmentParameterivEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glGetFramebufferAttachmentParameterivEXT == (GdkGLProc_glGetFramebufferAttachmentParameterivEXT) -1)
    _procs_GL_EXT_framebuffer_object.glGetFramebufferAttachmentParameterivEXT =
      (GdkGLProc_glGetFramebufferAttachmentParameterivEXT) gdk_gl_get_proc_address ("glGetFramebufferAttachmentParameterivEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGetFramebufferAttachmentParameterivEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glGetFramebufferAttachmentParameterivEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glGetFramebufferAttachmentParameterivEXT);
}

/* glGenerateMipmapEXT */
GdkGLProc
gdk_gl_get_glGenerateMipmapEXT (void)
{
  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (_procs_GL_EXT_framebuffer_object.glGenerateMipmapEXT == (GdkGLProc_glGenerateMipmapEXT) -1)
    _procs_GL_EXT_framebuffer_object.glGenerateMipmapEXT =
      (GdkGLProc_glGenerateMipmapEXT) gdk_gl_get_proc_address ("glGenerateMipmapEXT");

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_glGenerateMipmapEXT () - %s",
               (_procs_GL_EXT_framebuffer_object.glGenerateMipmapEXT) ? "supported" : "not supported"));

  return (GdkGLProc) (_procs_GL_EXT_framebuffer_object.glGenerateMipmapEXT);
}

/* Get GL_EXT_framebuffer_object functions */
GdkGL_GL_EXT_framebuffer_object *
gdk_gl_get_GL_EXT_framebuffer_object (void)
{
  static gint supported = -1;

  if (gdk_gl_context_get_current () == NULL)
    return NULL;

  if (supported == -1)
    {
      supported = gdk_gl_query_gl_extension ("GL_EXT_framebuffer_object");

      if (supported)
        {
          supported &= (gdk_gl_get_glIsRenderbufferEXT () != NULL);
          supported &= (gdk_gl_get_glBindRenderbufferEXT () != NULL);
          supported &= (gdk_gl_get_glDeleteRenderbuffersEXT () != NULL);
          supported &= (gdk_gl_get_glGenRenderbuffersEXT () != NULL);
          supported &= (gdk_gl_get_glRenderbufferStorageEXT () != NULL);
          supported &= (gdk_gl_get_glGetRenderbufferParameterivEXT () != NULL);
          supported &= (gdk_gl_get_glIsFramebufferEXT () != NULL);
          supported &= (gdk_gl_get_glBindFramebufferEXT () != NULL);
          supported &= (gdk_gl_get_glDeleteFramebuffersEXT () != NULL);
          supported &= (gdk_gl_get_glGenFramebuffersEXT () != NULL);
          supported &= (gdk_gl_get_glCheckFramebufferStatusEXT () != NULL);
          supported &= (gdk_gl_get_glFramebufferTexture1DEXT () != NULL);
          supported &= (gdk_gl_get_glFramebufferTexture2DEXT () != NULL);
          supported &= (gdk_gl_get_glFramebufferTexture3DEXT () != NULL);
          supported &= (gdk_gl_get_glFramebufferRenderbufferEXT () != NULL);
          supported &= (gdk_gl_get_glGetFramebufferAttachmentParameterivEXT () != NULL);
          supported &= (gdk_gl_get_glGenerateMipmapEXT () != NULL);
        }
    }

  GDK_GL_NOTE (MISC,
    g_message (" - gdk_gl_get_GL_EXT_framebuffer_object () - %s",
               (supported) ? "supported" : "not supported"));

  if (!supported)
    return NULL;

  return &_procs_GL_EXT_framebuffer_object;
}
