#ifndef __GTK_GL_EXT_FBO_SL_H__
#define __GTK_GL_EXT_FBO_SL_H__

#include <glib.h>
#include <GL/gl.h>

#include <gdk/gdkgldefs.h>
#include <gdk/gdkglquery.h>

#include "glext_fbo_sl.h"

G_BEGIN_DECLS

/*
 * GL_ARB_shader_objects
 */

/* glDeleteObjectARB */
typedef void (APIENTRY * GdkGLProc_glDeleteObjectARB) (GLhandleARB object);
GdkGLProc    gdk_gl_get_glDeleteObjectARB (void);
#define      gdk_gl_glDeleteObjectARB(proc, object) \
  ( ((GdkGLProc_glDeleteObjectARB) (proc)) (object) )

/* glGetHandleARB */
typedef GLhandleARB (APIENTRY * GdkGLProc_glGetHandleARB) (GLenum shaderType);
GdkGLProc    gdk_gl_get_glGetHandleARB (void);
#define      gdk_gl_glGetHandleARB(proc, shaderType) \
  ( ((GdkGLProc_glGetHandleARB) (proc)) (shaderType) )

/* glDetachObjectARB */
typedef void (APIENTRY * GdkGLProc_glDetachObjectARB) (GLhandleARB program, GLhandleARB shader);
GdkGLProc    gdk_gl_get_glDetachObjectARB (void);
#define      gdk_gl_glDetachObjectARB(proc, program, shader) \
  ( ((GdkGLProc_glDetachObjectARB) (proc)) (program, shader) )

/* glCreateShaderObjectARB */
typedef GLhandleARB (APIENTRY * GdkGLProc_glCreateShaderObjectARB) (GLenum shaderType);
GdkGLProc    gdk_gl_get_glCreateShaderObjectARB (void);
#define      gdk_gl_glCreateShaderObjectARB(proc, shaderType) \
  ( ((GdkGLProc_glCreateShaderObjectARB) (proc)) (shaderType) )

/* glShaderSourceARB */
typedef void (APIENTRY * GdkGLProc_glShaderSourceARB) (GLhandleARB shader, GLsizei number_strings, const GLcharARB** strings, const GLint* length);
GdkGLProc    gdk_gl_get_glShaderSourceARB (void);
#define      gdk_gl_glShaderSourceARB(proc, shader, number_strings, strings, length) \
  ( ((GdkGLProc_glShaderSourceARB) (proc)) (shader, number_strings, strings, length) )

/* glCompileShaderARB */
typedef void (APIENTRY * GdkGLProc_glCompileShaderARB) (GLhandleARB shader);
GdkGLProc    gdk_gl_get_glCompileShaderARB (void);
#define      gdk_gl_glCompileShaderARB(proc, shader) \
  ( ((GdkGLProc_glCompileShaderARB) (proc)) (shader) )

/* glCreateProgramObjectARB */
typedef GLhandleARB (APIENTRY * GdkGLProc_glCreateProgramObjectARB) (void);
GdkGLProc    gdk_gl_get_glCreateProgramObjectARB (void);
#define      gdk_gl_glCreateProgramObjectARB(proc) \
  ( ((GdkGLProc_glCreateProgramObjectARB) (proc)) () )

/* glAttachObjectARB */
typedef void (APIENTRY * GdkGLProc_glAttachObjectARB) (GLhandleARB program, GLhandleARB shader);
GdkGLProc    gdk_gl_get_glAttachObjectARB (void);
#define      gdk_gl_glAttachObjectARB(proc, program, shader) \
  ( ((GdkGLProc_glAttachObjectARB) (proc)) (program, shader) )

/* glLinkProgramARB */
typedef void (APIENTRY * GdkGLProc_glLinkProgramARB) (GLhandleARB program);
GdkGLProc    gdk_gl_get_glLinkProgramARB (void);
#define      gdk_gl_glLinkProgramARB(proc, program) \
  ( ((GdkGLProc_glLinkProgramARB) (proc)) (program) )

/* glUseProgramObjectARB */
typedef void (APIENTRY * GdkGLProc_glUseProgramObjectARB) (GLhandleARB program);
GdkGLProc    gdk_gl_get_glUseProgramObjectARB (void);
#define      gdk_gl_glUseProgramObjectARB(proc, program) \
  ( ((GdkGLProc_glUseProgramObjectARB) (proc)) (program) )

/* glValidateProgramARB */
typedef void (APIENTRY * GdkGLProc_glValidateProgramARB) (GLhandleARB program);
GdkGLProc    gdk_gl_get_glValidateProgramARB (void);
#define      gdk_gl_glValidateProgramARB(proc, program) \
  ( ((GdkGLProc_glValidateProgramARB) (proc)) (program) )

/* glUniform1fARB */
typedef void (APIENTRY * GdkGLProc_glUniform1fARB) (GLint location, GLfloat val);
GdkGLProc    gdk_gl_get_glUniform1fARB (void);
#define      gdk_gl_glUniform1fARB(proc, location, val) \
  ( ((GdkGLProc_glUniform1fARB) (proc)) (location, val) )

/* glUniform2fARB */
typedef void (APIENTRY * GdkGLProc_glUniform2fARB) (GLint location, GLfloat val1, GLfloat val2);
GdkGLProc    gdk_gl_get_glUniform2fARB (void);
#define      gdk_gl_glUniform2fARB(proc, location, val1, val2) \
  ( ((GdkGLProc_glUniform2fARB) (proc)) (location, val1, val2) )

/* glUniform3fARB */
typedef void (APIENTRY * GdkGLProc_glUniform3fARB) (GLint location, GLfloat val1, GLfloat val2, GLfloat val3);
GdkGLProc    gdk_gl_get_glUniform3fARB (void);
#define      gdk_gl_glUniform3fARB(proc, location, val1, val2, val3) \
  ( ((GdkGLProc_glUniform3fARB) (proc)) (location, val1, val2, val3) )

/* glUniform4fARB */
typedef void (APIENTRY * GdkGLProc_glUniform4fARB) (GLint location, GLfloat val1, GLfloat val2, GLfloat val3, GLfloat val4);
GdkGLProc    gdk_gl_get_glUniform4fARB (void);
#define      gdk_gl_glUniform4fARB(proc, location, val1, val2, val3, val4) \
  ( ((GdkGLProc_glUniform4fARB) (proc)) (location, val1, val2, val3, val4) )

/* glUniform1iARB */
typedef void (APIENTRY * GdkGLProc_glUniform1iARB) (GLint location, GLint val);
GdkGLProc    gdk_gl_get_glUniform1iARB (void);
#define      gdk_gl_glUniform1iARB(proc, location, val) \
  ( ((GdkGLProc_glUniform1iARB) (proc)) (location, val) )

/* glUniform2iARB */
typedef void (APIENTRY * GdkGLProc_glUniform2iARB) (GLint location, GLint val1, GLint val2);
GdkGLProc    gdk_gl_get_glUniform2iARB (void);
#define      gdk_gl_glUniform2iARB(proc, location, val1, val2) \
  ( ((GdkGLProc_glUniform2iARB) (proc)) (location, val1, val2) )

/* glUniform3iARB */
typedef void (APIENTRY * GdkGLProc_glUniform3iARB) (GLint location, GLint val1, GLint val2, GLint val3);
GdkGLProc    gdk_gl_get_glUniform3iARB (void);
#define      gdk_gl_glUniform3iARB(proc, location, val1, val2, val3) \
  ( ((GdkGLProc_glUniform3iARB) (proc)) (location, val1, val2, val3) )

/* glUniform4iARB */
typedef void (APIENTRY * GdkGLProc_glUniform4iARB) (GLint location, GLint val1, GLint val2, GLint val3, GLint val4);
GdkGLProc    gdk_gl_get_glUniform4iARB (void);
#define      gdk_gl_glUniform4iARB(proc, location, val1, val2, val3, val4) \
  ( ((GdkGLProc_glUniform4iARB) (proc)) (location, val1, val2, val3, val4) )

/* glUniform1fvARB */
typedef void (APIENTRY * GdkGLProc_glUniform1fvARB) (GLint location, GLsizei count, const GLfloat *vals);
GdkGLProc    gdk_gl_get_glUniform1fvARB (void);
#define      gdk_gl_glUniform1fvARB(proc, location, count, vals) \
  ( ((GdkGLProc_glUniform1fvARB) (proc)) (location, count, vals) )

/* glUniform2fvARB */
typedef void (APIENTRY * GdkGLProc_glUniform2fvARB) (GLint location, GLsizei count, const GLfloat *vals);
GdkGLProc    gdk_gl_get_glUniform2fvARB (void);
#define      gdk_gl_glUniform2fvARB(proc, location, count, vals) \
  ( ((GdkGLProc_glUniform2fvARB) (proc)) (location, count, vals) )

/* glUniform3fvARB */
typedef void (APIENTRY * GdkGLProc_glUniform3fvARB) (GLint location, GLsizei count, const GLfloat *vals);
GdkGLProc    gdk_gl_get_glUniform3fvARB (void);
#define      gdk_gl_glUniform3fvARB(proc, location, count, vals) \
  ( ((GdkGLProc_glUniform3fvARB) (proc)) (location, count, vals) )

/* glUniform4fvARB */
typedef void (APIENTRY * GdkGLProc_glUniform4fvARB) (GLint location, GLsizei count, const GLfloat *vals);
GdkGLProc    gdk_gl_get_glUniform4fvARB (void);
#define      gdk_gl_glUniform4fvARB(proc, location, count, vals) \
  ( ((GdkGLProc_glUniform4fvARB) (proc)) (location, count, vals) )

/* glUniform1ivARB */
typedef void (APIENTRY * GdkGLProc_glUniform1ivARB) (GLint location, GLsizei count, const GLint *vals);
GdkGLProc    gdk_gl_get_glUniform1ivARB (void);
#define      gdk_gl_glUniform1ivARB(proc, location, count, vals) \
  ( ((GdkGLProc_glUniform1ivARB) (proc)) (location, count, vals) )

/* glUniform2ivARB */
typedef void (APIENTRY * GdkGLProc_glUniform2ivARB) (GLint location, GLsizei count, const GLint *vals);
GdkGLProc    gdk_gl_get_glUniform2ivARB (void);
#define      gdk_gl_glUniform2ivARB(proc, location, count, vals) \
  ( ((GdkGLProc_glUniform2ivARB) (proc)) (location, count, vals) )

/* glUniform3ivARB */
typedef void (APIENTRY * GdkGLProc_glUniform3ivARB) (GLint location, GLsizei count, const GLint *vals);
GdkGLProc    gdk_gl_get_glUniform3ivARB (void);
#define      gdk_gl_glUniform3ivARB(proc, location, count, vals) \
  ( ((GdkGLProc_glUniform3ivARB) (proc)) (location, count, vals) )

/* glUniform4ivARB */
typedef void (APIENTRY * GdkGLProc_glUniform4ivARB) (GLint location, GLsizei count, const GLint *vals);
GdkGLProc    gdk_gl_get_glUniform4ivARB (void);
#define      gdk_gl_glUniform4ivARB(proc, location, count, vals) \
  ( ((GdkGLProc_glUniform4ivARB) (proc)) (location, count, vals) )

/* glUniformMatrix2fvARB */
typedef void (APIENTRY * GdkGLProc_glUniformMatrix2fvARB) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *vals);
GdkGLProc    gdk_gl_get_glUniformMatrix2fvARB (void);
#define      gdk_gl_glUniformMatrix2fvARB(proc, location, count, transpose, vals) \
  ( ((GdkGLProc_glUniformMatrix2fvARB) (proc)) (location, count, transpose, vals) )

/* glUniformMatrix3fvARB */
typedef void (APIENTRY * GdkGLProc_glUniformMatrix3fvARB) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *vals);
GdkGLProc    gdk_gl_get_glUniformMatrix3fvARB (void);
#define      gdk_gl_glUniformMatrix3fvARB(proc, location, count, transpose, vals) \
  ( ((GdkGLProc_glUniformMatrix3fvARB) (proc)) (location, count, transpose, vals) )

/* glUniformMatrix4fvARB */
typedef void (APIENTRY * GdkGLProc_glUniformMatrix4fvARB) (GLint location, GLsizei count, GLboolean transpose, const GLfloat *vals);
GdkGLProc    gdk_gl_get_glUniformMatrix4fvARB (void);
#define      gdk_gl_glUniformMatrix4fvARB(proc, location, count, transpose, vals) \
  ( ((GdkGLProc_glUniformMatrix4fvARB) (proc)) (location, count, transpose, vals) )

/* glGetObjectParameterfvARB */
typedef void (APIENTRY * GdkGLProc_glGetObjectParameterfvARB) (GLhandleARB object, GLenum pname, GLfloat* params);
GdkGLProc    gdk_gl_get_glGetObjectParameterfvARB (void);
#define      gdk_gl_glGetObjectParameterfvARB(proc, object, pname, params) \
  ( ((GdkGLProc_glGetObjectParameterfvARB) (proc)) (object, pname, params) )

/* glGetObjectParameterivARB */
typedef void (APIENTRY * GdkGLProc_glGetObjectParameterivARB) (GLhandleARB object, GLenum pname, GLint* params);
GdkGLProc    gdk_gl_get_glGetObjectParameterivARB (void);
#define      gdk_gl_glGetObjectParameterivARB(proc, object, pname, params) \
  ( ((GdkGLProc_glGetObjectParameterivARB) (proc)) (object, pname, params) )

/* glGetInfoLogARB */
typedef void (APIENTRY * GdkGLProc_glGetInfoLogARB) (GLhandleARB object, GLsizei max_lenght, GLsizei *length, GLcharARB *info_log);
GdkGLProc    gdk_gl_get_glGetInfoLogARB (void);
#define      gdk_gl_glGetInfoLogARB(proc, object, max_length, length, info_log) \
  ( ((GdkGLProc_glGetInfoLogARB) (proc)) (object, max_length, length, info_log) )

/* glGetAttachedObjectsARB */
typedef void (APIENTRY * GdkGLProc_glGetAttachedObjectsARB) (GLhandleARB container_object, GLsizei max_count, GLsizei *count, GLhandleARB *objects);
GdkGLProc    gdk_gl_get_glGetAttachedObjectsARB (void);
#define      gdk_gl_glGetAttachedObjectsARB(proc, container_object, max_count, count, objects) \
  ( ((GdkGLProc_glGetAttachedObjectsARB) (proc)) (container_object, max_count, count, objects) )

/* glGetUniformLocationARB */
typedef GLint (APIENTRY * GdkGLProc_glGetUniformLocationARB) (GLhandleARB program, const GLcharARB *name);
GdkGLProc    gdk_gl_get_glGetUniformLocationARB (void);
#define      gdk_gl_glGetUniformLocationARB(proc, program, name) \
  ( ((GdkGLProc_glGetUniformLocationARB) (proc)) (object, program, name) )

/* glGetActiveUniformARB */
typedef void (APIENTRY * GdkGLProc_glGetActiveUniformARB) (GLhandleARB program, GLuint index, GLsizei max_length, GLsizei *length, GLint *size, GLenum *type, GLcharARB *name);
GdkGLProc    gdk_gl_get_glGetActiveUniformARB (void);
#define      gdk_gl_glGetActiveUniformARB(proc, program, index, max_length, size, type, name) \
  ( ((GdkGLProc_glGetActiveUniformARB) (proc)) (program, index, max_length, size, type, name) )

/* glGetUniformfvARB */
typedef void (APIENTRY * GdkGLProc_glGetUniformfvARB) (GLhandleARB program, GLint location, GLfloat *params);
GdkGLProc    gdk_gl_get_glGetUniformfvARB (void);
#define      gdk_gl_glGetUniformfvARB(proc, program, location, params) \
  ( ((GdkGLProc_glGetUniformfvARB) (proc)) (program, location, params) )

/* glGetUniformivARB */
typedef void (APIENTRY * GdkGLProc_glGetUniformivARB) (GLhandleARB program, GLint location, GLint *params);
GdkGLProc    gdk_gl_get_glGetUniformivARB (void);
#define      gdk_gl_glGetUniformivARB(proc, program, location, params) \
  ( ((GdkGLProc_glGetUniformivARB) (proc)) (program, location, params) )

/* glGetShaderSourceARB */
typedef void (APIENTRY * GdkGLProc_glGetShaderSourceARB) (GLhandleARB object, GLsizei max_length, GLsizei *length, GLcharARB *source);
GdkGLProc    gdk_gl_get_glGetShaderSourceARB (void);
#define      gdk_gl_glGetShaderSourceARB(proc, object, max_length, length, source) \
  ( ((GdkGLProc_glGetShaderSourceARB) (proc)) (object, max_length, length, source) )

/* proc struct */

typedef struct _GdkGL_GL_ARB_shader_objects GdkGL_GL_ARB_shader_objects;

struct _GdkGL_GL_ARB_shader_objects
{
  GdkGLProc_glDeleteObjectARB glDeleteObjectARB;
  GdkGLProc_glGetHandleARB glGetHandleARB;
  GdkGLProc_glDetachObjectARB glDetachObjectARB;
  GdkGLProc_glCreateShaderObjectARB glCreateShaderObjectARB;
  GdkGLProc_glShaderSourceARB glShaderSourceARB;
  GdkGLProc_glCompileShaderARB glCompileShaderARB;
  GdkGLProc_glCreateProgramObjectARB glCreateProgramObjectARB;
  GdkGLProc_glAttachObjectARB glAttachObjectARB;
  GdkGLProc_glLinkProgramARB glLinkProgramARB;
  GdkGLProc_glUseProgramObjectARB glUseProgramObjectARB;
  GdkGLProc_glValidateProgramARB glValidateProgramARB;
  GdkGLProc_glUniform1fARB glUniform1fARB;
  GdkGLProc_glUniform2fARB glUniform2fARB;
  GdkGLProc_glUniform3fARB glUniform3fARB;
  GdkGLProc_glUniform4fARB glUniform4fARB;
  GdkGLProc_glUniform1iARB glUniform1iARB;
  GdkGLProc_glUniform2iARB glUniform2iARB;
  GdkGLProc_glUniform3iARB glUniform3iARB;
  GdkGLProc_glUniform4iARB glUniform4iARB;
  GdkGLProc_glUniform1fvARB glUniform1fvARB;
  GdkGLProc_glUniform2fvARB glUniform2fvARB;
  GdkGLProc_glUniform3fvARB glUniform3fvARB;
  GdkGLProc_glUniform4fvARB glUniform4fvARB;
  GdkGLProc_glUniform1ivARB glUniform1ivARB;
  GdkGLProc_glUniform2ivARB glUniform2ivARB;
  GdkGLProc_glUniform3ivARB glUniform3ivARB;
  GdkGLProc_glUniform4ivARB glUniform4ivARB;
  GdkGLProc_glUniformMatrix2fvARB glUniformMatrix2fvARB;
  GdkGLProc_glUniformMatrix3fvARB glUniformMatrix3fvARB;
  GdkGLProc_glUniformMatrix4fvARB glUniformMatrix4fvARB;
  GdkGLProc_glGetObjectParameterfvARB glGetObjectParameterfvARB;
  GdkGLProc_glGetObjectParameterivARB glGetObjectParameterivARB;
  GdkGLProc_glGetInfoLogARB glGetInfoLogARB;
  GdkGLProc_glGetAttachedObjectsARB glGetAttachedObjectsARB;
  GdkGLProc_glGetUniformLocationARB glGetUniformLocationARB;
  GdkGLProc_glGetActiveUniformARB glGetActiveUniformARB;
  GdkGLProc_glGetUniformfvARB glGetUniformfvARB;
  GdkGLProc_glGetUniformivARB glGetUniformivARB;
  GdkGLProc_glGetShaderSourceARB glGetShaderSourceARB;
};

GdkGL_GL_ARB_shader_objects *gdk_gl_get_GL_ARB_shader_objects (void);

/*
 * GL_EXT_framebuffer_object
 */

/* glIsRenderbufferEXT */
typedef GLboolean (APIENTRY * GdkGLProc_glIsRenderbufferEXT) (GLuint id);
GdkGLProc    gdk_gl_get_glIsRenderbufferEXT (void);
#define      gdk_gl_glIsRenderbufferEXT(proc, id) \
  ( ((GdkGLProc_glIsRenderbufferEXT) (proc)) (id) )

/* glBindRenderbufferEXT */
typedef void (APIENTRY * GdkGLProc_glBindRenderbufferEXT) (GLenum target, GLuint id);
GdkGLProc    gdk_gl_get_glBindRenderbufferEXT (void);
#define      gdk_gl_glBindRenderbufferEXT(proc, target, id) \
  ( ((GdkGLProc_glBindRenderbufferEXT) (proc)) (target, id) )

/* glDeleteRenderbuffersEXT */
typedef void (APIENTRY * GdkGLProc_glDeleteRenderbuffersEXT) (GLsizei count, GLuint *ids);
GdkGLProc    gdk_gl_get_glDeleteRenderbuffersEXT (void);
#define      gdk_gl_glDeleteRenderbuffersEXT(proc, count, ids) \
  ( ((GdkGLProc_glDeleteRenderbuffersEXT) (proc)) (count, ids) )

/* glGenRenderbuffersEXT */
typedef void (APIENTRY * GdkGLProc_glGenRenderbuffersEXT) (GLsizei count, GLuint *ids);
GdkGLProc    gdk_gl_get_glGenRenderbuffersEXT (void);
#define      gdk_gl_glGenRenderbuffersEXT(proc, count, ids) \
  ( ((GdkGLProc_glGenRenderbuffersEXT) (proc)) (count, ids) )

/* glRenderbufferStorageEXT */
typedef void (APIENTRY * GdkGLProc_glRenderbufferStorageEXT) (GLenum target, GLenum internalFormat, GLsizei width, GLsizei height);
GdkGLProc    gdk_gl_get_glRenderbufferStorageEXT (void);
#define      gdk_gl_glRenderbufferStorageEXT(proc, target, internalFormat, width, height) \
  ( ((GdkGLProc_glRenderbufferStorageEXT) (proc)) (target, internalFormat, width, height) )

/* glGetRenderbufferParameterivEXT */
typedef void (APIENTRY * GdkGLProc_glGetRenderbufferParameterivEXT) (GLenum target, GLenum pname, GLint *param);
GdkGLProc    gdk_gl_get_glGetRenderbufferParameterivEXT (void);
#define      gdk_gl_glGetRenderbufferParameterivEXT(proc, target, pname, param) \
  ( ((GdkGLProc_glGetRenderbufferParameterivEXT) (proc)) (target, pname, param) )

/* glIsFramebufferEXT */
typedef GLboolean (APIENTRY * GdkGLProc_glIsFramebufferEXT) (GLuint id);
GdkGLProc    gdk_gl_get_glIsFramebufferEXT (void);
#define      gdk_gl_glIsFramebufferEXT(proc, id) \
  ( ((GdkGLProc_glIsFramebufferEXT) (proc)) (id) )

/* glBindFramebufferEXT */
typedef void (APIENTRY * GdkGLProc_glBindFramebufferEXT) (GLenum target, GLuint id);
GdkGLProc    gdk_gl_get_glBindFramebufferEXT (void);
#define      gdk_gl_glBindFramebufferEXT(proc, target, id) \
  ( ((GdkGLProc_glBindFramebufferEXT) (proc)) (target, id) )

/* glDeleteFramebuffersEXT */
typedef void (APIENTRY * GdkGLProc_glDeleteFramebuffersEXT) (GLsizei count, GLuint *ids);
GdkGLProc    gdk_gl_get_glDeleteFramebuffersEXT (void);
#define      gdk_gl_glDeleteFramebuffersEXT(proc, count, ids) \
  ( ((GdkGLProc_glDeleteFramebuffersEXT) (proc)) (count, ids) )

/* glGenFramebuffersEXT */
typedef void (APIENTRY * GdkGLProc_glGenFramebuffersEXT) (GLsizei count, GLuint *ids);
GdkGLProc    gdk_gl_get_glGenFramebuffersEXT (void);
#define      gdk_gl_glGenFramebuffersEXT(proc, count, ids) \
  ( ((GdkGLProc_glGenFramebuffersEXT) (proc)) (count, ids) )

/* glCheckFramebufferStatusEXT */
typedef GLenum (APIENTRY * GdkGLProc_glCheckFramebufferStatusEXT) (GLenum target);
GdkGLProc    gdk_gl_get_glCheckFramebufferStatusEXT (void);
#define      gdk_gl_glCheckFramebufferStatusEXT(proc, target) \
  ( ((GdkGLProc_glCheckFramebufferStatusEXT) (proc)) (target) )

/* glFramebufferTexture1DEXT */
typedef void (APIENTRY * GdkGLProc_glFramebufferTexture1DEXT) (GLenum target, GLenum attachment, GLenum texTarget, GLuint texId, GLint level);
GdkGLProc    gdk_gl_get_glFramebufferTexture1DEXT (void);
#define      gdk_gl_glFramebufferTexture1DEXT(proc, target, attachment, texTarget, texId, level) \
  ( ((GdkGLProc_glFramebufferTexture1DEXT) (proc)) (target, attachment, texTarget, texId, level) )

/* glFramebufferTexture2DEXT */
typedef void (APIENTRY * GdkGLProc_glFramebufferTexture2DEXT) (GLenum target, GLenum attachment, GLenum texTarget, GLuint texId, GLint level);
GdkGLProc    gdk_gl_get_glFramebufferTexture2DEXT (void);
#define      gdk_gl_glFramebufferTexture2DEXT(proc, target, attachment, texTarget, texId, level) \
  ( ((GdkGLProc_glFramebufferTexture2DEXT) (proc)) (target, attachment, texTarget, texId, level) )

/* glFramebufferTexture3DEXT */
typedef void (APIENTRY * GdkGLProc_glFramebufferTexture3DEXT) (GLenum target, GLenum attachment, GLenum texTarget, GLuint texId, GLint level, GLint zOffset);
GdkGLProc    gdk_gl_get_glFramebufferTexture3DEXT (void);
#define      gdk_gl_glFramebufferTexture3DEXT(proc, target, attachment, texTarget, texId, level, zOffset) \
  ( ((GdkGLProc_glFramebufferTexture3DEXT) (proc)) (target, attachment, texTarget, texId, level, zOffset) )

/* glFramebufferRenderbufferEXT */
typedef void (APIENTRY * GdkGLProc_glFramebufferRenderbufferEXT) (GLenum target, GLenum attachment, GLenum rbTarget, GLuint rbId);
GdkGLProc    gdk_gl_get_glFramebufferRenderbufferEXT (void);
#define      gdk_gl_glFramebufferRenderbufferEXT(proc, target, attachment, rbTarget, rbId) \
  ( ((GdkGLProc_glFramebufferRenderbufferEXT) (proc)) (target, attachment, rbTarget, rbId) )

/* glGetFramebufferAttachmentParameterivEXT */
typedef void (APIENTRY * GdkGLProc_glGetFramebufferAttachmentParameterivEXT) (GLenum target, GLenum attachment, GLenum pname, GLint *param);
GdkGLProc    gdk_gl_get_glGetFramebufferAttachmentParameterivEXT (void);
#define      gdk_gl_glGetFramebufferAttachmentParameterivEXT(proc, target, attachment, pname, param) \
  ( ((GdkGLProc_glGetFramebufferAttachmentParameterivEXT) (proc)) (target, attachment, pname, param) )

/* glGenerateMipmapEXT */
typedef void (APIENTRY * GdkGLProc_glGenerateMipmapEXT) (GLenum target);
GdkGLProc    gdk_gl_get_glGenerateMipmapEXT (void);
#define      gdk_gl_glGenerateMipmapEXT(proc, target) \
  ( ((GdkGLProc_glGenerateMipmapEXT) (proc)) (target) )

/* proc struct */

typedef struct _GdkGL_GL_EXT_framebuffer_object GdkGL_GL_EXT_framebuffer_object;

struct _GdkGL_GL_EXT_framebuffer_object
{
  GdkGLProc_glIsRenderbufferEXT glIsRenderbufferEXT;
  GdkGLProc_glBindRenderbufferEXT glBindRenderbufferEXT;
  GdkGLProc_glDeleteRenderbuffersEXT glDeleteRenderbuffersEXT;
  GdkGLProc_glGenRenderbuffersEXT glGenRenderbuffersEXT;
  GdkGLProc_glRenderbufferStorageEXT glRenderbufferStorageEXT;
  GdkGLProc_glGetRenderbufferParameterivEXT glGetRenderbufferParameterivEXT;
  GdkGLProc_glIsFramebufferEXT glIsFramebufferEXT;
  GdkGLProc_glBindFramebufferEXT glBindFramebufferEXT;
  GdkGLProc_glDeleteFramebuffersEXT glDeleteFramebuffersEXT;
  GdkGLProc_glGenFramebuffersEXT glGenFramebuffersEXT;
  GdkGLProc_glCheckFramebufferStatusEXT glCheckFramebufferStatusEXT;
  GdkGLProc_glFramebufferTexture1DEXT glFramebufferTexture1DEXT;
  GdkGLProc_glFramebufferTexture2DEXT glFramebufferTexture2DEXT;
  GdkGLProc_glFramebufferTexture3DEXT glFramebufferTexture3DEXT;
  GdkGLProc_glFramebufferRenderbufferEXT glFramebufferRenderbufferEXT;
  GdkGLProc_glGetFramebufferAttachmentParameterivEXT glGetFramebufferAttachmentParameterivEXT;
  GdkGLProc_glGenerateMipmapEXT glGenerateMipmapEXT;
};

GdkGL_GL_EXT_framebuffer_object *gdk_gl_get_GL_EXT_framebuffer_object (void);

G_END_DECLS

#endif /* __GTK_GL_EXT_FBO_SL_H__ */
